namespace Encompass.Engines
{
    internal class ComponentUpdater<TComponent> : Engine where TComponent : struct, IComponent
    {
        public ComponentUpdater() : base()
        {
            receiveTypes.Add(typeof(ComponentWriteMessage<TComponent>));
        }

        public override void Update(double dt)
        {
            foreach (var componentUpdateMessage in ReadMessages<ComponentWriteMessage<TComponent>>())
            {
                UpdateComponentInWorld(componentUpdateMessage.componentID, componentUpdateMessage.component);
            }
        }
    }
}